-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
local M = {}
M.type = "auxilliary"
M.relevantDevice = nil

local min = math.min
local max = math.max
local abs = math.abs
local leftWheel = nil
local rightWheel = nil
M.throttle_R = 0
M.throttle_L = 0
local hull = nil
local span = nil

local function updateGFX(dt)
  local throttle_R = min(max(electrics.values.throttle_R, 0), 1)
  local throttle_L = min(max(electrics.values.throttle_L, 0), 1)  
  

  
  if electrics.values.throttle == 0 then
   electrics.values.throttle_R = (max(-electrics.values.steering_input/2, 0))--* (max(electrics.values.throttle, 0.7))
   electrics.values.throttle_L = (max(electrics.values.steering_input/2, 0))-- * (max(electrics.values.throttle, 0.7))
  else

	electrics.values.throttle_R =  electrics.values.throttle-(max(electrics.values.steering_input, 0))
	electrics.values.throttle_L = electrics.values.throttle-(max(-electrics.values.steering_input, 0)) 

  end  

  local brakeR = min(max(electrics.values.brake_r, 0), 1)
  local brakeL = min(max(electrics.values.brake_l, 0), 1)
  rightWheel.desiredBrakingTorque = 2*(rightWheel.brakeTorque * brakeR)
  leftWheel.desiredBrakingTorque = 2*(leftWheel.brakeTorque * brakeL)


  
  if electrics.values.brake == 1 then
   electrics.values.brake_r =  1-(max(-electrics.values.steering_input/2, 0))
   electrics.values.brake_l = 1-(max(electrics.values.steering_input/2, 0))
  else
   electrics.values.brake_r = (max(electrics.values.steering_input, 0))--* (max(electrics.values.throttle, 0.7))
   electrics.values.brake_l = (max(-electrics.values.steering_input, 0))-- * (max(electrics.values.throttle, 0.7))
  end  
  

  
  electrics.values.hull_alt = min(max(electrics.values.hull_alt + electrics.values.hull_updown_change * dt * 1, -1), 1)
  electrics.values.span  = min(max(electrics.values.span + electrics.values.span_updown_change * dt * 1, -1), 1)
  
end

local function init(jbeamData)
  electrics.values.brake_l = 0
  electrics.values.brake_r = 0
  electrics.values.brake_combined = 0
  electrics.values.hull_alt = 0
  electrics.values.hull_updown_change = 0

  electrics.values.throttle_L = 0
  electrics.values.throttle_R = 0

  electrics.values.span = 0
  electrics.values.span_updown_change = 0  
  for _,wd in pairs(wheels.wheels) do
    if wd.name == "blijotank_spr_R" then rightWheel = wd end
    if wd.name == "blijotank_spr_L" then leftWheel = wd end
	if wd.name == "hull" then hull = wd end
	if wd.name == "span" then span = wd end
  end
end

M.init = init
M.updateGFX = updateGFX
M.update = update

return M